"use strict";

var Annotation = require("./Annotation");
var TargettingStructure = require("./TargettingStructure");

function Chemical(javaObject) {
  TargettingStructure.call(this, javaObject);
  if (javaObject !== undefined) {
    this.setReferences(javaObject.references);
    this.setDescription(javaObject.description);
    this.setSynonyms(javaObject.synonyms);

    this.setDirectEvidence(javaObject.directEvidence);
    this.setDirectEvidenceReferences(javaObject.directEvidenceReferences);
  }
}

Chemical.prototype = Object.create(TargettingStructure.prototype);
Chemical.prototype.constructor = Chemical;

Chemical.prototype.setDirectEvidence = function(directeEvidence) {
  this._directeEvidence = directeEvidence;
};

Chemical.prototype.getDirectEvidence = function() {
  return this._directeEvidence;
};

Chemical.prototype.setDirectEvidenceReferences = function(directeEvidenceReferences) {
  this._directeEvidenceReferences = [];
  for (var i = 0; i < directeEvidenceReferences.length; i++) {
    this._directeEvidenceReferences.push(new Annotation(directeEvidenceReferences[i]));
  }
};

Chemical.prototype.getDirectEvidenceReferences = function() {
  return this._directEvidenceReferences;
};

Chemical.prototype.setBrandNames = function(brandNames) {
  this._brandNames = brandNames;
};

Chemical.prototype.getBrandNames = function() {
  return this._brandNames;
};

Chemical.prototype.setReferences = function(references) {
  this._references = [];
  for (var i = 0; i < references.length; i++) {
    this._references.push(new Annotation(references[i]));
  }
};

Chemical.prototype.getReferences = function() {
  return this._references;
};

Chemical.prototype.setSynonyms = function(synonyms) {
  this._synonyms = synonyms;
};

Chemical.prototype.getSynonyms = function() {
  return this._synonyms;
};

Chemical.prototype.setDescription = function(description) {
  this._description = description;
};

Chemical.prototype.getDescription = function() {
  return this._description;
};

Chemical.prototype.setBloodBrainBarrier = function(bloodBrainBarrier) {
  this._bloodBrainBarrier = bloodBrainBarrier;
};

Chemical.prototype.getBloodBrainBarrier = function() {
  return this._bloodBrainBarrier;
};

module.exports = Chemical;
